Attribute VB_Name = "Module1"
Public Const FILE_ATTRIBUTE_DIRECTORY = &H10
Public Const INVALID_HANDLE_VALUE = -1
Public Const DRIVE_FIXED = 3
Public Const MAX_PATH = 260
Public Const MAXDWORD = &HFFFFFFF
Public Type FILETIME
   dwLowDateTime As Long
   dwHighDateTime As Long
End Type
Public Type WIN32_FIND_DATA
   dwFileAttributes As Long
   ftCreationTime As FILETIME
   ftLastAccessTime As FILETIME
   ftLastWriteTime As FILETIME
   nFileSizeHigh As Long
   nFileSizeLow As Long
   dwReserved0 As Long
   dwReserved1 As Long
   cFileName As String * MAX_PATH
   cAlternate As String * 14
End Type
Public Type FILE_PARAMS
   bRecurse As Boolean     'set True to perform a recursive search
   bList As Boolean        'set True to add results to listbox
   bFound As Boolean       'set only with SearchTreeForFile methods
   sFileRoot As String     'search starting point, ie c:\, c:\winnt\
   sFileNameExt As String  'filename/filespec to locate, ie *.dll, notepad.exe
   sResult As String       'path to file. Set only with SearchTreeForFile methods
   nFileCount As Long      'total file count matching filespec. Set in FindXXX only
   nFileSize As Double     'total file size matching filespec. Set in FindXXX only
End Type
Public Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Public Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long

Public sAllFiles() As String
Public nCount As Long
Public bCancel As Boolean
Public Sub GetAllFilesSpecified(FP As FILE_PARAMS)
   Dim drvCount As Long
   Dim sBuffer As String
   Dim currDrive As String
   If FP.sFileRoot = "all fixed disks/partitions" Then
     sBuffer = Space$(64)
     drvCount = GetLogicalDriveStrings(Len(sBuffer), sBuffer)
     If drvCount Then
       sBuffer = Left$(sBuffer, drvCount)
       Do Until sBuffer = ""
         FP.sFileRoot = StripItem(sBuffer)
         If GetDriveType(FP.sFileRoot) = DRIVE_FIXED Then
           DoEvents
           If bCancel Then Exit Do
           Call SearchForFilesArray(FP)
         End If
         Loop
      End If
   Else
     Call SearchForFilesArray(FP)
    End If
End Sub


Private Sub GetFileInformation(FP As FILE_PARAMS)
   Dim WFD As WIN32_FIND_DATA
   Dim hFile As Long
   Dim sPath As String
   Dim sRoot As String
   Dim sTmp As String
   
   sRoot = QualifyPath(FP.sFileRoot)
   sPath = sRoot & FP.sFileNameExt
   hFile = FindFirstFile(sPath, WFD)
   If hFile <> INVALID_HANDLE_VALUE Then
     Do
       If Not (WFD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY Then
          sTmp = TrimNull(WFD.cFileName)
          nCount = nCount + 1
          sAllFiles(nCount) = sRoot & sTmp
       End If
     Loop While FindNextFile(hFile, WFD)
     hFile = FindClose(hFile)
   End If
End Sub
Private Function QualifyPath(sPath As String) As String
   If Right$(sPath, 1) <> "\" Then
     QualifyPath = sPath & "\"
   Else
     QualifyPath = sPath
   End If
End Function

Private Sub SearchForFilesArray(FP As FILE_PARAMS)
'  Dim WFD As WIN32_FIND_DATA
'  Dim hFile As Long
'  Dim sPath As String
'  Dim sRoot As String
'  Dim sTmp As String
'
'  sRoot = QualifyPath(FP.sFileRoot)
'  sPath = sRoot & "*.*"
'  hFile = FindFirstFile(sPath, WFD)
'  If hFile <> INVALID_HANDLE_VALUE Then
'    Call GetFileInformation(FP)
'    Do
'      'continue looping until FindNextFile returns 0 (no more matches)
'    Loop While FindNextFile(hFile, WFD)
'    hFile = FindClose(hFile)
'  End If
 Dim WFD As WIN32_FIND_DATA
  Dim hFile As Long
  Dim sPath As String
  Dim sRoot As String
  Dim sTmp As String
  sRoot = QualifyPath(FP.sFileRoot)
  sPath = sRoot & "*.*"
  hFile = FindFirstFile(sPath, WFD)
  If hFile <> INVALID_HANDLE_VALUE Then
    Call GetFileInformation(FP)
    Do
       If SubOn = 1 Then
         If (WFD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) Then
           sTmp = TrimNull(WFD.cFileName)
           If sTmp <> "." And sTmp <> ".." Then
             FP.sFileRoot = sRoot & sTmp 'get the file
             nCount = nCount + 1
             sAllFiles(nCount) = FP.sFileRoot
             Call SearchForFilesArray(FP)
           End If
         End If
      End If
    Loop While FindNextFile(hFile, WFD)
    hFile = FindClose(hFile)
  End If
End Sub

Function StripItem(startStrg As String) As String
   Dim pos As Integer
   pos = InStr(startStrg, Chr$(0))
   If pos Then
     StripItem = Mid(startStrg, 1, pos - 1)
     startStrg = Mid(startStrg, pos + 1, Len(startStrg))
   End If
End Function

Public Function TrimNull(startstr As String) As String
  Dim pos As Integer
  pos = InStr(startstr, Chr$(0))
  If pos Then
    TrimNull = Left$(startstr, pos - 1)
    Exit Function
  End If
  TrimNull = startstr
End Function


Public Sub SaveImageList()
   Dim n As Long
   For n = 1 To UBound(sAllFiles)
     ImageList((lastN - nCount) + n) = sAllFiles(n)
   Next
End Sub





